Index: uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.c
===================================================================
--- uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -39,5 +39,4 @@
 
 #include <usb/usb.h>
-#include <usb/host/utils/malloc32.h>
 
 #include "mem_access.h"
@@ -70,8 +69,10 @@
 };
 
+#include <usb/debug.h>
+
 /**
  * Initialize EHCI TD.
  * @param instance TD structure to initialize.
- * @param next Next TD in ED list.
+ * @param next_phys Next TD in ED list.
  * @param direction Used to determine PID, BOTH means setup PID.
  * @param buffer Pointer to the first byte of transferred data.
@@ -80,7 +81,6 @@
  *        any other value means that ED toggle will be used.
  */
-void td_init(td_t *instance, const td_t *next,
-    usb_direction_t direction, const void *buffer, size_t size, int toggle,
-    bool ioc)
+void td_init(td_t *instance, uintptr_t next_phys, uintptr_t buffer,
+    usb_direction_t direction, size_t size, int toggle, bool ioc)
 {
 	assert(instance);
@@ -98,22 +98,19 @@
 	}
 
-	if (buffer != NULL) {
+	if (buffer != 0) {
 		assert(size != 0);
 		for (unsigned i = 0; (i < ARRAY_SIZE(instance->buffer_pointer))
 		    && size; ++i) {
-			const uintptr_t page =
-			    (addr_to_phys(buffer) & TD_BUFFER_POINTER_MASK);
-			const size_t offset =
-			    ((uintptr_t)buffer & TD_BUFFER_POINTER_OFFSET_MASK);
+			const uintptr_t offset = buffer & TD_BUFFER_POINTER_OFFSET_MASK;
 			assert(offset == 0 || i == 0);
-			size -= min((4096 - offset), size);
-			buffer += min((4096 - offset), size);
-			EHCI_MEM32_WR(instance->buffer_pointer[i],
-			    page | offset);
+			const size_t this_size = min(size, 4096 - offset);
+			EHCI_MEM32_WR(instance->buffer_pointer[i], buffer);
+			size -= this_size;
+			buffer += this_size;
 		}
 	}
 
-	EHCI_MEM32_WR(instance->next, next ?
-	    LINK_POINTER_TD(addr_to_phys(next)) : LINK_POINTER_TERM);
+	EHCI_MEM32_WR(instance->next, next_phys ?
+	    LINK_POINTER_TD(next_phys) : LINK_POINTER_TERM);
 
 	EHCI_MEM32_WR(instance->alternate, LINK_POINTER_TERM);
Index: uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -37,4 +37,5 @@
 #include <stddef.h>
 #include <stdint.h>
+#include <macros.h>
 #include "link_pointer.h"
 #include "mem_access.h"
@@ -75,5 +76,11 @@
 	/* 64 bit struct only */
 	volatile uint32_t extended_bp[5];
-} td_t;
+
+	/* TDs must be 32-byte aligned */
+	PADD32 [3];
+
+} __attribute__((packed)) td_t;
+
+static_assert(sizeof(td_t) % 32 == 0);
 
 static inline bool td_active(const td_t *td)
@@ -92,5 +99,5 @@
 errno_t td_error(const td_t *td);
 
-void td_init(td_t *td, const td_t *next, usb_direction_t dir, const void * buf,
+void td_init(td_t *td, uintptr_t next_phys, uintptr_t buf, usb_direction_t dir,
     size_t buf_size, int toggle, bool ioc);
 
Index: uspace/drv/bus/usb/ehci/main.c
===================================================================
--- uspace/drv/bus/usb/ehci/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ehci/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -35,95 +35,23 @@
  */
 
-#include <ddf/driver.h>
-#include <ddf/interrupt.h>
-#include <device/hw_res.h>
-#include <errno.h>
-#include <str_error.h>
 #include <io/logctl.h>
-
-#include <usb_iface.h>
-#include <usb/debug.h>
-#include <usb/host/ddf_helpers.h>
+#include <usb/host/hcd.h>
 
 #include "res.h"
 #include "hc.h"
-#include "ehci_endpoint.h"
 
 #define NAME "ehci"
 
-static errno_t ehci_driver_init(hcd_t *, const hw_res_list_parsed_t *, bool);
-static void ehci_driver_fini(hcd_t *);
+static const hc_driver_t ehci_driver = {
+	.name = NAME,
+	.hc_device_size = sizeof(hc_t),
 
-static const ddf_hc_driver_t ehci_hc_driver = {
+	.hc_add = hc_add,
+	.irq_code_gen = hc_gen_irq_code,
 	.claim = disable_legacy,
-	.hc_speed = USB_SPEED_HIGH,
-	.irq_code_gen = ehci_hc_gen_irq_code,
-	.init = ehci_driver_init,
-	.fini = ehci_driver_fini,
-	.name = "EHCI-PCI",
-	.ops = {
-		.schedule       = ehci_hc_schedule,
-		.ep_add_hook    = ehci_endpoint_init,
-		.ep_remove_hook = ehci_endpoint_fini,
-		.irq_hook       = ehci_hc_interrupt,
-		.status_hook    = ehci_hc_status,
-	}
+	.start = hc_start,
+	.setup_root_hub = hc_setup_roothub,
+	.hc_gone = hc_gone,
 };
-
-
-static errno_t ehci_driver_init(hcd_t *hcd, const hw_res_list_parsed_t *res,
-    bool irq)
-{
-	assert(hcd);
-	assert(hcd_get_driver_data(hcd) == NULL);
-
-	hc_t *instance = malloc(sizeof(hc_t));
-	if (!instance)
-		return ENOMEM;
-
-	const errno_t ret = hc_init(instance, res, irq);
-	if (ret == EOK) {
-		hcd_set_implementation(hcd, instance, &ehci_hc_driver.ops);
-	} else {
-		free(instance);
-	}
-	return ret;
-}
-
-static void ehci_driver_fini(hcd_t *hcd)
-{
-	assert(hcd);
-	hc_t *hc = hcd_get_driver_data(hcd);
-	if (hc)
-		hc_fini(hc);
-
-	free(hc);
-	hcd_set_implementation(hcd, NULL, NULL);
-}
-
-/** Initializes a new ddf driver instance of EHCI hcd.
- *
- * @param[in] device DDF instance of the device to initialize.
- * @return Error code.
- */
-static errno_t ehci_dev_add(ddf_dev_t *device)
-{
-	usb_log_debug("ehci_dev_add() called\n");
-	assert(device);
-
-	return hcd_ddf_add_hc(device, &ehci_hc_driver);
-
-}
-
-
-static const driver_ops_t ehci_driver_ops = {
-	.dev_add = ehci_dev_add,
-};
-
-static const driver_t ehci_driver = {
-	.name = NAME,
-	.driver_ops = &ehci_driver_ops
-};
-
 
 /** Initializes global driver structures (NONE).
@@ -139,5 +67,5 @@
 	log_init(NAME);
 	logctl_set_log_level(NAME, LVL_NOTE);
-	return ddf_driver_main(&ehci_driver);
+	return hc_driver_main(&ehci_driver);
 }
 
Index: uspace/drv/bus/usb/ehci/res.c
===================================================================
--- uspace/drv/bus/usb/ehci/res.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ehci/res.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -45,4 +45,5 @@
 #include <pci_dev_iface.h>
 
+#include "hc.h"
 #include "res.h"
 #include "ehci_regs.h"
@@ -73,16 +74,16 @@
 	    eecp + USBLEGSUP_OFFSET, &usblegsup);
 	if (ret != EOK) {
-		usb_log_error("Failed to read USBLEGSUP: %s.\n", str_error(ret));
-		return ret;
-	}
-	usb_log_debug2("USBLEGSUP: %" PRIx32 ".\n", usblegsup);
+		usb_log_error("Failed to read USBLEGSUP: %s.", str_error(ret));
+		return ret;
+	}
+	usb_log_debug2("USBLEGSUP: %" PRIx32 ".", usblegsup);
 
 	/* Request control from firmware/BIOS by writing 1 to highest
 	 * byte. (OS Control semaphore)*/
-	usb_log_debug("Requesting OS control.\n");
+	usb_log_debug("Requesting OS control.");
 	ret = pci_config_space_write_8(parent_sess,
 	    eecp + USBLEGSUP_OFFSET + 3, 1);
 	if (ret != EOK) {
-		usb_log_error("Failed to request OS EHCI control: %s.\n",
+		usb_log_error("Failed to request OS EHCI control: %s.",
 		    str_error(ret));
 		return ret;
@@ -102,5 +103,5 @@
 
 	if ((usblegsup & USBLEGSUP_BIOS_CONTROL) == 0) {
-		usb_log_info("BIOS released control after %zu usec.\n", wait);
+		usb_log_info("BIOS released control after %zu usec.", wait);
 		return EOK;
 	}
@@ -108,9 +109,9 @@
 	/* BIOS failed to hand over control, this should not happen. */
 	usb_log_warning( "BIOS failed to release control after "
-	    "%zu usecs, force it.\n", wait);
+	    "%zu usecs, force it.", wait);
 	ret = pci_config_space_write_32(parent_sess,
 	    eecp + USBLEGSUP_OFFSET, USBLEGSUP_OS_CONTROL);
 	if (ret != EOK) {
-		usb_log_error("Failed to force OS control: %s.\n",
+		usb_log_error("Failed to force OS control: %s.",
 		    str_error(ret));
 		return ret;
@@ -129,9 +130,9 @@
 		    eecp + USBLEGCTLSTS_OFFSET, &usblegctlsts);
 		if (ret != EOK) {
-			usb_log_error("Failed to get USBLEGCTLSTS: %s.\n",
+			usb_log_error("Failed to get USBLEGCTLSTS: %s.",
 			    str_error(ret));
 			return ret;
 		}
-		usb_log_debug2("USBLEGCTLSTS: %" PRIx32 ".\n", usblegctlsts);
+		usb_log_debug2("USBLEGCTLSTS: %" PRIx32 ".", usblegctlsts);
 		/*
 		 * Zero SMI enables in legacy control register.
@@ -142,5 +143,5 @@
 		    eecp + USBLEGCTLSTS_OFFSET, 0xe0000000);
 		if (ret != EOK) {
-			usb_log_error("Failed to zero USBLEGCTLSTS: %s\n",
+			usb_log_error("Failed to zero USBLEGCTLSTS: %s",
 			    str_error(ret));
 			return ret;
@@ -152,9 +153,9 @@
 		    eecp + USBLEGCTLSTS_OFFSET, &usblegctlsts);
 		if (ret != EOK) {
-			usb_log_error("Failed to get USBLEGCTLSTS 2: %s.\n",
+			usb_log_error("Failed to get USBLEGCTLSTS 2: %s.",
 			    str_error(ret));
 			return ret;
 		}
-		usb_log_debug2("Zeroed USBLEGCTLSTS: %" PRIx32 ".\n",
+		usb_log_debug2("Zeroed USBLEGCTLSTS: %" PRIx32 ".",
 		    usblegctlsts);
 	}
@@ -164,53 +165,24 @@
 	    eecp + USBLEGSUP_OFFSET, &usblegsup);
 	if (ret != EOK) {
-		usb_log_error("Failed to read USBLEGSUP: %s.\n",
-		    str_error(ret));
-		return ret;
-	}
-	usb_log_debug2("USBLEGSUP: %" PRIx32 ".\n", usblegsup);
+		usb_log_error("Failed to read USBLEGSUP: %s.",
+		    str_error(ret));
+		return ret;
+	}
+	usb_log_debug2("USBLEGSUP: %" PRIx32 ".", usblegsup);
 	return ret;
 }
 
-errno_t disable_legacy(ddf_dev_t *device)
+errno_t disable_legacy(hc_device_t *hcd)
 {
-	assert(device);
-
-	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
+	hc_t *hc = hcd_to_hc(hcd);
+
+	async_sess_t *parent_sess = ddf_dev_parent_sess_get(hcd->ddf_dev);
 	if (parent_sess == NULL)
 		return ENOMEM;
 
-	usb_log_debug("Disabling EHCI legacy support.\n");
-
-	hw_res_list_parsed_t res;
-	hw_res_list_parsed_init(&res);
-	errno_t ret = hw_res_get_list_parsed(parent_sess, &res, 0);
-	if (ret != EOK) {
-		usb_log_error("Failed to get resource list: %s\n",
-		    str_error(ret));
-		goto clean;
-	}
-
-	if (res.mem_ranges.count < 1) {
-		usb_log_error("Incorrect mem range count: %zu",
-		    res.mem_ranges.count);
-		ret = EINVAL;
-		goto clean;
-	}
-
-	/* Map EHCI registers */
-	void *regs = NULL;
-	ret = pio_enable_range(&res.mem_ranges.ranges[0], &regs);
-	if (ret != EOK) {
-		usb_log_error("Failed to map registers %p: %s.\n",
-		    RNGABSPTR(res.mem_ranges.ranges[0]), str_error(ret));
-		goto clean;
-	}
-
-	usb_log_debug("Registers mapped at: %p.\n", regs);
-
-	ehci_caps_regs_t *ehci_caps = regs;
-
-	const uint32_t hcc_params = EHCI_RD(ehci_caps->hccparams);
-	usb_log_debug2("Value of hcc params register: %x.\n", hcc_params);
+	usb_log_debug("Disabling EHCI legacy support.");
+
+	const uint32_t hcc_params = EHCI_RD(hc->caps->hccparams);
+	usb_log_debug2("Value of hcc params register: %x.", hcc_params);
 
 	/* Read value of EHCI Extended Capabilities Pointer
@@ -218,15 +190,14 @@
 	const uint32_t eecp =
 	    (hcc_params >> EHCI_CAPS_HCC_EECP_SHIFT) & EHCI_CAPS_HCC_EECP_MASK;
-	usb_log_debug2("Value of EECP: %x.\n", eecp);
-
-	ret = disable_extended_caps(parent_sess, eecp);
-	if (ret != EOK) {
-		usb_log_error("Failed to disable extended capabilities: %s.\n",
+	usb_log_debug2("Value of EECP: %x.", eecp);
+
+	int ret = disable_extended_caps(parent_sess, eecp);
+	if (ret != EOK) {
+		usb_log_error("Failed to disable extended capabilities: %s.",
 		    str_error(ret));
 		    goto clean;
 	}
 clean:
-	//TODO unmap registers
-	hw_res_list_parsed_clean(&res);
+	async_hangup(parent_sess);
 	return ret;
 }
Index: uspace/drv/bus/usb/ehci/res.h
===================================================================
--- uspace/drv/bus/usb/ehci/res.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ehci/res.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -36,8 +36,7 @@
 #define DRV_EHCI_PCI_H
 
-#include <ddf/driver.h>
-#include <device/hw_res_parsed.h>
+typedef struct hc_device hc_device_t;
 
-extern errno_t disable_legacy(ddf_dev_t *);
+extern errno_t disable_legacy(hc_device_t *);
 
 #endif
Index: uspace/drv/bus/usb/ohci/Makefile
===================================================================
--- uspace/drv/bus/usb/ohci/Makefile	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ohci/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -38,5 +38,5 @@
 	main.c \
 	ohci_batch.c \
-	ohci_endpoint.c \
+	ohci_bus.c \
 	ohci_rh.c \
 	hw_struct/endpoint_descriptor.c \
Index: uspace/drv/bus/usb/ohci/endpoint_list.c
===================================================================
--- uspace/drv/bus/usb/ohci/endpoint_list.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ohci/endpoint_list.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -57,9 +57,9 @@
 	instance->list_head = malloc32(sizeof(ed_t));
 	if (!instance->list_head) {
-		usb_log_error("Failed to allocate list head.\n");
+		usb_log_error("Failed to allocate list head.");
 		return ENOMEM;
 	}
 	instance->list_head_pa = addr_to_phys(instance->list_head);
-	usb_log_debug2("Transfer list %s setup with ED: %p(0x%0" PRIx32 ")).\n",
+	usb_log_debug2("Transfer list %s setup with ED: %p(0x%0" PRIx32 ")).",
 	    name, instance->list_head, instance->list_head_pa);
 
@@ -96,5 +96,5 @@
 	assert(instance);
 	assert(ep);
-	usb_log_debug2("Queue %s: Adding endpoint(%p).\n", instance->name, ep);
+	usb_log_debug2("Queue %s: Adding endpoint(%p).", instance->name, ep);
 
 	fibril_mutex_lock(&instance->guard);
@@ -108,5 +108,5 @@
 		/* There are active EDs, get the last one */
 		ohci_endpoint_t *last = list_get_instance(
-		    list_last(&instance->endpoint_list), ohci_endpoint_t, link);
+		    list_last(&instance->endpoint_list), ohci_endpoint_t, eplist_link);
 		last_ed = last->ed;
 	}
@@ -122,12 +122,12 @@
 
 	/* Add to the sw list */
-	list_append(&ep->link, &instance->endpoint_list);
+	list_append(&ep->eplist_link, &instance->endpoint_list);
 
 	ohci_endpoint_t *first = list_get_instance(
-	    list_first(&instance->endpoint_list), ohci_endpoint_t, link);
-	usb_log_debug("HCD EP(%p) added to list %s, first is %p(%p).\n",
+	    list_first(&instance->endpoint_list), ohci_endpoint_t, eplist_link);
+	usb_log_debug("HCD EP(%p) added to list %s, first is %p(%p).",
 		ep, instance->name, first, first->ed);
 	if (last_ed == instance->list_head) {
-		usb_log_debug2("%s head ED(%p-0x%0" PRIx32 "): %x:%x:%x:%x.\n",
+		usb_log_debug2("%s head ED(%p-0x%0" PRIx32 "): %x:%x:%x:%x.",
 		    instance->name, last_ed, instance->list_head_pa,
 		    last_ed->status, last_ed->td_tail, last_ed->td_head,
@@ -151,10 +151,10 @@
 	fibril_mutex_lock(&instance->guard);
 
-	usb_log_debug2("Queue %s: removing endpoint(%p).\n", instance->name, ep);
+	usb_log_debug2("Queue %s: removing endpoint(%p).", instance->name, ep);
 
 	const char *qpos = NULL;
 	ed_t *prev_ed;
 	/* Remove from the hardware queue */
-	if (list_first(&instance->endpoint_list) == &ep->link) {
+	if (list_first(&instance->endpoint_list) == &ep->eplist_link) {
 		/* I'm the first one here */
 		prev_ed = instance->list_head;
@@ -162,5 +162,5 @@
 	} else {
 		ohci_endpoint_t *prev =
-		    list_get_instance(ep->link.prev, ohci_endpoint_t, link);
+		    list_get_instance(ep->eplist_link.prev, ohci_endpoint_t, eplist_link);
 		prev_ed = prev->ed;
 		qpos = "NOT FIRST";
@@ -171,9 +171,9 @@
 	write_barrier();
 
-	usb_log_debug("HCD EP(%p) removed (%s) from %s, next %x.\n",
+	usb_log_debug("HCD EP(%p) removed (%s) from %s, next %x.",
 	    ep, qpos, instance->name, ep->ed->next);
 
 	/* Remove from the endpoint list */
-	list_remove(&ep->link);
+	list_remove(&ep->eplist_link);
 	fibril_mutex_unlock(&instance->guard);
 }
Index: uspace/drv/bus/usb/ohci/endpoint_list.h
===================================================================
--- uspace/drv/bus/usb/ohci/endpoint_list.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ohci/endpoint_list.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -41,5 +41,5 @@
 #include <usb/host/utils/malloc32.h>
 
-#include "ohci_endpoint.h"
+#include "ohci_bus.h"
 #include "hw_struct/endpoint_descriptor.h"
 
Index: uspace/drv/bus/usb/ohci/hc.c
===================================================================
--- uspace/drv/bus/usb/ohci/hc.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/ohci/hc.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -45,7 +45,8 @@
 
 #include <usb/debug.h>
+#include <usb/host/utility.h>
 #include <usb/usb.h>
 
-#include "ohci_endpoint.h"
+#include "ohci_bus.h"
 #include "ohci_batch.h"
 
@@ -89,6 +90,4 @@
 };
 
-static void hc_gain_control(hc_t *instance);
-static void hc_start(hc_t *instance);
 static errno_t hc_init_transfer_lists(hc_t *instance);
 static errno_t hc_init_memory(hc_t *instance);
@@ -103,5 +102,5 @@
  * @return Error code.
  */
-errno_t ohci_hc_gen_irq_code(irq_code_t *code, const hw_res_list_parsed_t *hw_res, int *irq)
+errno_t hc_gen_irq_code(irq_code_t *code, hc_device_t *hcd, const hw_res_list_parsed_t *hw_res, int *irq)
 {
 	assert(code);
@@ -138,5 +137,5 @@
 	OHCI_WR(code->cmds[1].value, OHCI_USED_INTERRUPTS);
 
-	usb_log_debug("Memory mapped regs at %p (size %zu), IRQ %d.\n",
+	usb_log_debug("Memory mapped regs at %p (size %zu), IRQ %d.",
 	    RNGABSPTR(regs), RNGSZ(regs), hw_res->irqs.irqs[0]);
 
@@ -152,7 +151,7 @@
  * @return Error code
  */
-errno_t hc_init(hc_t *instance, const hw_res_list_parsed_t *hw_res, bool interrupts)
-{
-	assert(instance);
+errno_t hc_add(hc_device_t *hcd, const hw_res_list_parsed_t *hw_res)
+{
+	hc_t *instance = hcd_to_hc(hcd);
 	assert(hw_res);
 	if (hw_res->mem_ranges.count != 1 ||
@@ -163,19 +162,18 @@
 	    (void **) &instance->registers);
 	if (ret != EOK) {
-		usb_log_error("Failed to gain access to registers: %s.\n",
+		usb_log_error("Failed to gain access to registers: %s.",
 		    str_error(ret));
 		return ret;
 	}
-	usb_log_debug("Device registers at %" PRIx64 " (%zuB) accessible.\n",
+	usb_log_debug("Device registers at %" PRIx64 " (%zuB) accessible.",
 	    hw_res->mem_ranges.ranges[0].address.absolute,
 	    hw_res->mem_ranges.ranges[0].size);
 
-	list_initialize(&instance->pending_batches);
+	list_initialize(&instance->pending_endpoints);
 	fibril_mutex_initialize(&instance->guard);
-	instance->hw_interrupts = interrupts;
 
 	ret = hc_init_memory(instance);
 	if (ret != EOK) {
-		usb_log_error("Failed to create OHCI memory structures: %s.\n",
+		usb_log_error("Failed to create OHCI memory structures: %s.",
 		    str_error(ret));
 		// TODO: We should disable pio access here
@@ -183,9 +181,4 @@
 	}
 
-	hc_gain_control(instance);
-
-	ohci_rh_init(&instance->rh, instance->registers, "ohci rh");
-	hc_start(instance);
-
 	return EOK;
 }
@@ -195,9 +188,10 @@
  * @param[in] instance Host controller structure to use.
  */
-void hc_fini(hc_t *instance)
+int hc_gone(hc_device_t *instance)
 {
 	assert(instance);
 	/* TODO: implement*/
-};
+	return ENOTSUP;
+}
 
 void hc_enqueue_endpoint(hc_t *instance, const endpoint_t *ep)
@@ -269,14 +263,16 @@
 }
 
-errno_t ohci_hc_status(hcd_t *hcd, uint32_t *status)
-{
-	assert(hcd);
+errno_t ohci_hc_status(bus_t *bus_base, uint32_t *status)
+{
+	assert(bus_base);
 	assert(status);
-	hc_t *instance = hcd_get_driver_data(hcd);
-	assert(instance);
-
-	if (instance->registers){
-		*status = OHCI_RD(instance->registers->interrupt_status);
-		OHCI_WR(instance->registers->interrupt_status, *status);
+
+	ohci_bus_t *bus = (ohci_bus_t *) bus_base;
+	hc_t *hc = bus->hc;
+	assert(hc);
+
+	if (hc->registers){
+		*status = OHCI_RD(hc->registers->interrupt_status);
+		OHCI_WR(hc->registers->interrupt_status, *status);
 	}
 	return EOK;
@@ -289,22 +285,35 @@
  * @return Error code.
  */
-errno_t ohci_hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
-{
-	assert(hcd);
-	hc_t *instance = hcd_get_driver_data(hcd);
-	assert(instance);
+errno_t ohci_hc_schedule(usb_transfer_batch_t *batch)
+{
+	assert(batch);
+
+	ohci_bus_t *bus = (ohci_bus_t *) endpoint_get_bus(batch->ep);
+	hc_t *hc = bus->hc;
+	assert(hc);
 
 	/* Check for root hub communication */
-	if (batch->ep->address == ohci_rh_get_address(&instance->rh)) {
-		usb_log_debug("OHCI root hub request.\n");
-		return ohci_rh_schedule(&instance->rh, batch);
-	}
+	if (batch->target.address == ohci_rh_get_address(&hc->rh)) {
+		usb_log_debug("OHCI root hub request.");
+		return ohci_rh_schedule(&hc->rh, batch);
+	}
+
+	endpoint_t *ep = batch->ep;
+	ohci_endpoint_t * const ohci_ep = ohci_endpoint_get(ep);
 	ohci_transfer_batch_t *ohci_batch = ohci_transfer_batch_get(batch);
-	if (!ohci_batch)
-		return ENOMEM;
-
-	fibril_mutex_lock(&instance->guard);
-	list_append(&ohci_batch->link, &instance->pending_batches);
+	int err;
+
+	fibril_mutex_lock(&hc->guard);
+	if ((err = endpoint_activate_locked(ep, batch))) {
+		fibril_mutex_unlock(&hc->guard);
+		return err;
+	}
+
+	if ((err = ohci_transfer_batch_prepare(ohci_batch)))
+		return err;
+
 	ohci_transfer_batch_commit(ohci_batch);
+	list_append(&ohci_ep->pending_link, &hc->pending_endpoints);
+	fibril_mutex_unlock(&hc->guard);
 
 	/* Control and bulk schedules need a kick to start working */
@@ -312,13 +321,13 @@
 	{
 	case USB_TRANSFER_CONTROL:
-		OHCI_SET(instance->registers->command_status, CS_CLF);
+		OHCI_SET(hc->registers->command_status, CS_CLF);
 		break;
 	case USB_TRANSFER_BULK:
-		OHCI_SET(instance->registers->command_status, CS_BLF);
+		OHCI_SET(hc->registers->command_status, CS_BLF);
 		break;
 	default:
 		break;
 	}
-	fibril_mutex_unlock(&instance->guard);
+
 	return EOK;
 }
@@ -329,43 +338,49 @@
  * @param[in] status Value of the status register at the time of interrupt.
  */
-void ohci_hc_interrupt(hcd_t *hcd, uint32_t status)
-{
-	assert(hcd);
-	hc_t *instance = hcd_get_driver_data(hcd);
+void ohci_hc_interrupt(bus_t *bus_base, uint32_t status)
+{
+	assert(bus_base);
+
+	ohci_bus_t *bus = (ohci_bus_t *) bus_base;
+	hc_t *hc = bus->hc;
+	assert(hc);
+
 	status = OHCI_RD(status);
-	assert(instance);
+	assert(hc);
 	if ((status & ~I_SF) == 0) /* ignore sof status */
 		return;
-	usb_log_debug2("OHCI(%p) interrupt: %x.\n", instance, status);
+	usb_log_debug2("OHCI(%p) interrupt: %x.", hc, status);
 	if (status & I_RHSC)
-		ohci_rh_interrupt(&instance->rh);
+		ohci_rh_interrupt(&hc->rh);
 
 	if (status & I_WDH) {
-		fibril_mutex_lock(&instance->guard);
-		usb_log_debug2("HCCA: %p-%#" PRIx32 " (%p).\n", instance->hcca,
-		    OHCI_RD(instance->registers->hcca),
-		    (void *) addr_to_phys(instance->hcca));
-		usb_log_debug2("Periodic current: %#" PRIx32 ".\n",
-		    OHCI_RD(instance->registers->periodic_current));
-
-		link_t *current = list_first(&instance->pending_batches);
-		while (current && current != &instance->pending_batches.head) {
-			link_t *next = current->next;
-			ohci_transfer_batch_t *batch =
-			    ohci_transfer_batch_from_link(current);
-
-			if (ohci_transfer_batch_is_complete(batch)) {
+		fibril_mutex_lock(&hc->guard);
+		usb_log_debug2("HCCA: %p-%#" PRIx32 " (%p).", hc->hcca,
+		    OHCI_RD(hc->registers->hcca),
+		    (void *) addr_to_phys(hc->hcca));
+		usb_log_debug2("Periodic current: %#" PRIx32 ".",
+		    OHCI_RD(hc->registers->periodic_current));
+
+		list_foreach_safe(hc->pending_endpoints, current, next) {
+			ohci_endpoint_t *ep
+				= list_get_instance(current, ohci_endpoint_t, pending_link);
+
+			ohci_transfer_batch_t *batch
+				= ohci_transfer_batch_get(ep->base.active_batch);
+			assert(batch);
+
+			if (ohci_transfer_batch_check_completed(batch)) {
+				endpoint_deactivate_locked(&ep->base);
 				list_remove(current);
-				ohci_transfer_batch_finish_dispose(batch);
+				hc_reset_toggles(&batch->base, &ohci_ep_toggle_reset);
+				usb_transfer_batch_finish(&batch->base);
 			}
-
-			current = next;
 		}
-		fibril_mutex_unlock(&instance->guard);
+		fibril_mutex_unlock(&hc->guard);
 	}
 
 	if (status & I_UE) {
-		usb_log_fatal("Error like no other!\n");
-		hc_start(instance);
+		usb_log_fatal("Error like no other!");
+		hc_start(&hc->base);
 	}
 
@@ -379,9 +394,9 @@
  * @param[in] instance OHCI hc driver structure.
  */
-void hc_gain_control(hc_t *instance)
-{
-	assert(instance);
-
-	usb_log_debug("Requesting OHCI control.\n");
+int hc_gain_control(hc_device_t *hcd)
+{
+	hc_t *instance = hcd_to_hc(hcd);
+
+	usb_log_debug("Requesting OHCI control.");
 	if (OHCI_RD(instance->registers->revision) & R_LEGACY_FLAG) {
 		/* Turn off legacy emulation, it should be enough to zero
@@ -392,5 +407,5 @@
 		volatile uint32_t *ohci_emulation_reg =
 		(uint32_t*)((char*)instance->registers + LEGACY_REGS_OFFSET);
-		usb_log_debug("OHCI legacy register %p: %x.\n",
+		usb_log_debug("OHCI legacy register %p: %x.",
 		    ohci_emulation_reg, OHCI_RD(*ohci_emulation_reg));
 		/* Zero everything but A20State */
@@ -398,5 +413,5 @@
 		OHCI_CLR(*ohci_emulation_reg, ~0x100);
 		usb_log_debug(
-		    "OHCI legacy register (should be 0 or 0x100) %p: %x.\n",
+		    "OHCI legacy register (should be 0 or 0x100) %p: %x.",
 		    ohci_emulation_reg, OHCI_RD(*ohci_emulation_reg));
 	}
@@ -404,5 +419,5 @@
 	/* Interrupt routing enabled => smm driver is active */
 	if (OHCI_RD(instance->registers->control) & C_IR) {
-		usb_log_debug("SMM driver: request ownership change.\n");
+		usb_log_debug("SMM driver: request ownership change.");
 		// TODO: should we ack interrupts before doing this?
 		OHCI_SET(instance->registers->command_status, CS_OCR);
@@ -411,8 +426,8 @@
 			async_usleep(1000);
 		}
-		usb_log_info("SMM driver: Ownership taken.\n");
+		usb_log_info("SMM driver: Ownership taken.");
 		C_HCFS_SET(instance->registers->control, C_HCFS_RESET);
 		async_usleep(50000);
-		return;
+		return EOK;
 	}
 
@@ -420,20 +435,21 @@
 	/* Interrupt routing disabled && status != USB_RESET => BIOS active */
 	if (hc_status != C_HCFS_RESET) {
-		usb_log_debug("BIOS driver found.\n");
+		usb_log_debug("BIOS driver found.");
 		if (hc_status == C_HCFS_OPERATIONAL) {
-			usb_log_info("BIOS driver: HC operational.\n");
-			return;
+			usb_log_info("BIOS driver: HC operational.");
+			return EOK;
 		}
 		/* HC is suspended assert resume for 20ms */
 		C_HCFS_SET(instance->registers->control, C_HCFS_RESUME);
 		async_usleep(20000);
-		usb_log_info("BIOS driver: HC resumed.\n");
-		return;
+		usb_log_info("BIOS driver: HC resumed.");
+		return EOK;
 	}
 
 	/* HC is in reset (hw startup) => no other driver
 	 * maintain reset for at least the time specified in USB spec (50 ms)*/
-	usb_log_debug("Host controller found in reset state.\n");
+	usb_log_debug("Host controller found in reset state.");
 	async_usleep(50000);
+	return EOK;
 }
 
@@ -442,16 +458,19 @@
  * @param[in] instance OHCI hc driver structure.
  */
-void hc_start(hc_t *instance)
-{
+int hc_start(hc_device_t *hcd)
+{
+	hc_t *instance = hcd_to_hc(hcd);
+	ohci_rh_init(&instance->rh, instance->registers, &instance->guard, "ohci rh");
+
 	/* OHCI guide page 42 */
 	assert(instance);
-	usb_log_debug2("Started hc initialization routine.\n");
+	usb_log_debug2("Started hc initialization routine.");
 
 	/* Save contents of fm_interval register */
 	const uint32_t fm_interval = OHCI_RD(instance->registers->fm_interval);
-	usb_log_debug2("Old value of HcFmInterval: %x.\n", fm_interval);
+	usb_log_debug2("Old value of HcFmInterval: %x.", fm_interval);
 
 	/* Reset hc */
-	usb_log_debug2("HC reset.\n");
+	usb_log_debug2("HC reset.");
 	size_t time = 0;
 	OHCI_WR(instance->registers->command_status, CS_HCR);
@@ -460,5 +479,5 @@
 		time += 10;
 	}
-	usb_log_debug2("HC reset complete in %zu us.\n", time);
+	usb_log_debug2("HC reset complete in %zu us.", time);
 
 	/* Restore fm_interval */
@@ -467,5 +486,5 @@
 
 	/* hc is now in suspend state */
-	usb_log_debug2("HC should be in suspend state(%x).\n",
+	usb_log_debug2("HC should be in suspend state(%x).",
 	    OHCI_RD(instance->registers->control));
 
@@ -476,5 +495,5 @@
 	OHCI_WR(instance->registers->bulk_head,
 	    instance->lists[USB_TRANSFER_BULK].list_head_pa);
-	usb_log_debug2("Bulk HEAD set to: %p (%#" PRIx32 ").\n",
+	usb_log_debug2("Bulk HEAD set to: %p (%#" PRIx32 ").",
 	    instance->lists[USB_TRANSFER_BULK].list_head,
 	    instance->lists[USB_TRANSFER_BULK].list_head_pa);
@@ -482,5 +501,5 @@
 	OHCI_WR(instance->registers->control_head,
 	    instance->lists[USB_TRANSFER_CONTROL].list_head_pa);
-	usb_log_debug2("Control HEAD set to: %p (%#" PRIx32 ").\n",
+	usb_log_debug2("Control HEAD set to: %p (%#" PRIx32 ").",
 	    instance->lists[USB_TRANSFER_CONTROL].list_head,
 	    instance->lists[USB_TRANSFER_CONTROL].list_head_pa);
@@ -488,12 +507,12 @@
 	/* Enable queues */
 	OHCI_SET(instance->registers->control, (C_PLE | C_IE | C_CLE | C_BLE));
-	usb_log_debug("Queues enabled(%x).\n",
+	usb_log_debug("Queues enabled(%x).",
 	    OHCI_RD(instance->registers->control));
 
 	/* Enable interrupts */
-	if (instance->hw_interrupts) {
+	if (instance->base.irq_cap >= 0) {
 		OHCI_WR(instance->registers->interrupt_enable,
 		    OHCI_USED_INTERRUPTS);
-		usb_log_debug("Enabled interrupts: %x.\n",
+		usb_log_debug("Enabled interrupts: %x.",
 		    OHCI_RD(instance->registers->interrupt_enable));
 		OHCI_WR(instance->registers->interrupt_enable, I_MI);
@@ -505,10 +524,20 @@
 	OHCI_WR(instance->registers->periodic_start,
 	    ((frame_length / 10) * 9) & PS_MASK << PS_SHIFT);
-	usb_log_debug2("All periodic start set to: %x(%u - 90%% of %d).\n",
+	usb_log_debug2("All periodic start set to: %x(%u - 90%% of %d).",
 	    OHCI_RD(instance->registers->periodic_start),
 	    OHCI_RD(instance->registers->periodic_start), frame_length);
 	C_HCFS_SET(instance->registers->control, C_HCFS_OPERATIONAL);
-	usb_log_debug("OHCI HC up and running (ctl_reg=0x%x).\n",
+	usb_log_debug("OHCI HC up and running (ctl_reg=0x%x).",
 	    OHCI_RD(instance->registers->control));
+
+	return EOK;
+}
+
+/**
+ * Setup roothub as a virtual hub.
+ */
+int hc_setup_roothub(hc_device_t *hcd)
+{
+	return hc_setup_virtual_root_hub(hcd, USB_SPEED_FULL);
 }
 
@@ -526,5 +555,5 @@
 	const errno_t ret = endpoint_list_init(&instance->lists[type], name); \
 	if (ret != EOK) { \
-		usb_log_error("Failed to setup %s endpoint list: %s.\n", \
+		usb_log_error("Failed to setup %s endpoint list: %s.", \
 		    name, str_error(ret)); \
 		endpoint_list_fini(&instance->lists[USB_TRANSFER_ISOCHRONOUS]);\
@@ -558,5 +587,5 @@
 	memset(&instance->rh, 0, sizeof(instance->rh));
 	/* Init queues */
-	const errno_t ret = hc_init_transfer_lists(instance);
+	errno_t ret = hc_init_transfer_lists(instance);
 	if (ret != EOK) {
 		return ret;
@@ -567,5 +596,5 @@
 	if (instance->hcca == NULL)
 		return ENOMEM;
-	usb_log_debug2("OHCI HCCA initialized at %p.\n", instance->hcca);
+	usb_log_debug2("OHCI HCCA initialized at %p.", instance->hcca);
 
 	for (unsigned i = 0; i < HCCA_INT_EP_COUNT; ++i) {
@@ -573,8 +602,16 @@
 		    instance->lists[USB_TRANSFER_INTERRUPT].list_head_pa);
 	}
-	usb_log_debug2("Interrupt HEADs set to: %p (%#" PRIx32 ").\n",
+	usb_log_debug2("Interrupt HEADs set to: %p (%#" PRIx32 ").",
 	    instance->lists[USB_TRANSFER_INTERRUPT].list_head,
 	    instance->lists[USB_TRANSFER_INTERRUPT].list_head_pa);
 
+	if ((ret = ohci_bus_init(&instance->bus, instance))) {
+		usb_log_error("HC(%p): Failed to setup bus : %s",
+		    instance, str_error(ret));
+		return ret;
+	}
+
+	hc_device_setup(&instance->base, (bus_t *) &instance->bus);
+
 	return EOK;
 }
